import "choerodon-ui/pro/lib/form/style";
import _Form from "@hzero-front-ui/c7n-ui/lib/FormPro";
import "choerodon-ui/pro/lib/select/style";
import _Select from "choerodon-ui/pro/lib/select";

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/* eslint-disable max-len */
import React, { useCallback, useState } from 'react';
import { Page, Header, Content, Breadcrumb } from '@choerodon/boot';
import { observer } from 'mobx-react-lite';
import Loading from "../../../components/loading";
import MaxTagPopover from "../Component/MaxTagPopover";
import TimePicker from "../Component/TimePicker";
import NoChart from "../Component/NoChart";
import HeaderButtons from "../Component/HeaderButtons";
import PipelineTable from "./components/table";
import { usePipelineDurationStore } from "./stores";
import { useReportsStore } from "../stores";
import Chart from "./components/chart";
import "./index.less";

var PipelineTriggerDuration = function PipelineTriggerDuration() {
  var _usePipelineDurationS = usePipelineDurationStore(),
      formatMessage = _usePipelineDurationS.formatMessage,
      history = _usePipelineDurationS.history,
      search = _usePipelineDurationS.history.location.search,
      prefixCls = _usePipelineDurationS.prefixCls,
      intlPrefix = _usePipelineDurationS.intlPrefix,
      selectDs = _usePipelineDurationS.selectDs,
      tableDs = _usePipelineDurationS.tableDs,
      chartDs = _usePipelineDurationS.chartDs,
      optionsDs = _usePipelineDurationS.optionsDs;

  var _useState = useState('seven'),
      _useState2 = _slicedToArray(_useState, 2),
      dateType = _useState2[0],
      setDateType = _useState2[1];

  var handleDateChoose = function handleDateChoose(type) {
    setDateType(type);
  };

  var _useReportsStore = useReportsStore(),
      ReportsStore = _useReportsStore.ReportsStore;

  var handleRefresh = useCallback(function () {
    optionsDs.query();
    chartDs.query();
    tableDs.query();
  }, []);
  var loadCharts = useCallback(function () {
    var startTime = ReportsStore.getStartTime.format('YYYY-MM-DD HH:mm:ss');
    var endTime = ReportsStore.getEndTime.format('YYYY-MM-DD HH:mm:ss');
    chartDs.setQueryParameter('startTime', startTime);
    chartDs.setQueryParameter('endTime', endTime);
    tableDs.setQueryParameter('startTime', startTime);
    tableDs.setQueryParameter('endTime', endTime);
    chartDs.query();
    tableDs.query();
  }, [ReportsStore.getStartTime, ReportsStore.getEndTime]); // @ts-ignore

  var maxTagNode = useCallback(function (value) {
    return /*#__PURE__*/React.createElement(MaxTagPopover, {
      dataSource: optionsDs.toData(),
      value: value
    });
  }, [optionsDs.records]);

  var renderContent = function renderContent() {
    if (optionsDs.status === 'loading') {
      return /*#__PURE__*/React.createElement(Loading, {
        display: true
      });
    }

    if (!optionsDs.length) {
      // @ts-ignore
      return /*#__PURE__*/React.createElement(NoChart, {
        getProRole: ReportsStore.getProRole,
        type: "pipeline"
      });
    }

    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-form")
    }, /*#__PURE__*/React.createElement(_Form, {
      dataSet: selectDs,
      className: "".concat(prefixCls, "-form-content")
    }, /*#__PURE__*/React.createElement(_Select, {
      name: "pipelineIds",
      searchable: true,
      clearButton: false,
      maxTagCount: 3,
      maxTagPlaceholder: maxTagNode
    })), /*#__PURE__*/React.createElement(TimePicker // @ts-ignore
    , {
      startTime: ReportsStore.getStartDate,
      endTime: ReportsStore.getEndDate,
      func: loadCharts,
      type: dateType,
      onChange: handleDateChoose,
      store: ReportsStore
    })), /*#__PURE__*/React.createElement(Chart, null), /*#__PURE__*/React.createElement(PipelineTable, {
      tableDs: tableDs
    }));
  };

  return /*#__PURE__*/React.createElement(Page, {
    className: prefixCls
  }, /*#__PURE__*/React.createElement(Header, {
    title: formatMessage({
      id: "".concat(intlPrefix, ".title")
    })
  }, /*#__PURE__*/React.createElement(HeaderButtons, {
    refresh: handleRefresh,
    reportKey: "pipeline-duration",
    reportType: "develop"
  })), /*#__PURE__*/React.createElement(Breadcrumb, {
    title: formatMessage({
      id: 'report.pipeline-duration.head'
    })
  }), /*#__PURE__*/React.createElement(Content, {
    className: "".concat(prefixCls, "-content")
  }, renderContent()));
};

export default observer(PipelineTriggerDuration);